/* 3ICE: I chose the 4th task. */
//Stratgia: (by me, Berezvai Dniel, A32BO2)
//Enum3ICE felsorolja a szmokat.
//Conv3ICE talaktja BASE3-ba.
//Digits3ICE felsorolja a szmjegyeket. (Enumerator)
//Count3ICE megszmolja a felsorolsbl mennyi kettes van a szmban.
//First3ICE visszaadja az els jt (2 db 2-es van pontosan).

//Tesztelve: 8, 17, 20, 23-ra mkdik.
//Tovbbi helyes rtkek: 24 25 26 44 47 50 51 52 56 59 60 61
//Tovbb nem ellenriztem, nehz az tvlts :)

#include "library/seqinfileenumerator.hpp"
#include "library/linsearch.hpp"
#include "library/summation.hpp"
#include "library/counting.hpp"
#include <iostream>
#include <string>

using namespace std;

class Enum3ICE : public Enumerator<int> {
protected:
	SeqInFileEnumerator<int>* enor;
	int _current;
	bool _end;
public:
	Enum3ICE(const string& str) {
		cout << "Enum3ICE:SeqInFileEnumerator ctor called with " << str << endl;
		//3ICE: Az inputfjl ltezst kell ellenrizni.
		try {
			enor = new SeqInFileEnumerator<int>(str);
		}
		catch (SeqInFileEnumerator<int>::Exceptions ex) {
			if (ex == SeqInFileEnumerator<int>::OPEN_ERROR) {
				cout << "ERROR: File \"" << str << "\" not found!" << endl;
				char c; cin >> c;
				exit(1);
			}
			else {
				cout << "Future-aware error handling! (In case SeqInFileEnumerator is updated.)" << endl;
				cout << "While attempting to open \"" << str << "\" the program encountered an unknown exception code: " << ex << endl;
				char c; cin >> c;
				exit(2);
			}
		}
	}
	~Enum3ICE() {
		cout << "Enum3ICE:SeqInFileEnumerator dtor called." << endl;
		delete enor;//3ICE: This might not be correct...
	}
	void first() {
		cout << "Enum3ICE.SeqInFileEnumerator first called" << endl;
		enor->first(); next();
	}
	void next();//3ICE: Defined at the end of the code.
	bool end() const { return _end; }
	int current() const { return _current; }
};

template <class T>
class Conv3ICE : public Summation<T, double> {
private:
	double remainder;
	int count;

protected:
	void init() {
		cout << "Conv3ICE:Summation.init called." << endl;
		*Summation<T, double>::_result = 0;
		remainder = .0;
		count = 0;
	}

	Conv3ICE() : Summation<T, double>() {
		cout << "Conv3ICE:Summation ctor called by Count3ICE." << endl;
	}
	void add(const T& e) {
		++count;
		int result = e % 3;
		remainder += e;
		*Summation<T, double>::_result = remainder / count;
		cout << "Conv3ICE:Summation.add ran for " << e << " with: count=" << count << " remainder=" << remainder << " count=" << count << " _result=" << *Summation<T, double>::_result << " result=" << result << endl;
	}
};

class Digits3ICE : public Enumerator<int> {
protected:
	int _current;
	bool _end;
public:
	Digits3ICE(const int i) {
		cout << "Digits3ICE:Enumerator ctor called with " << i << endl;
	}
	void first() {
		cout << "Digits3ICE.Enumerator first called" << endl;
		next();
	}
	void next() {
		//Conv3ICE count_pr(_current);

	}
	bool end() const { return _end; }
	int current() const { return _current; }
};

class Count3ICE : public Conv3ICE<int> {
private:
	int remainder;

	void first() {
		cout << "Count3ICE.first called. " << endl;
	}
	bool whileCond(const int& current) const {
		cout << "Count3ICE.whileCond for " << current << " returns: " << remainder << "%3>1 ?= " << (remainder % 3 > 1) << endl;
		return remainder % 3 > 1;
	}
public:
	Count3ICE(const int& current) : Conv3ICE<int>(), remainder(0) {
		cout << "Count3ICE ctor:" << current << endl;
	}
};

void Enum3ICE::next() {
	if (_end = enor->end()) {
		cout << "Enum3ICE.end() is true. EOF reached. Setting _end to true. Returning..." << endl;
		return;
	}
	_current = enor->current();
	cout << endl << "Enum3ICE.next called with " << _current << endl;
	Count3ICE count_pr(_current);
	Digits3ICE digits_p(_current);
	count_pr.addEnumerator(&digits_p);
	count_pr.run();
	cout << "Enum3ICE.next for " << _current << " ran successfully." << endl << "=====" << endl;
	enor->next();
}

class First3ICE : public LinSearch<int, false> {//3ICE: Igazzal lell hamar, nem tallja meg. Hamissal viszont lass sok bemenetre.
	int num = 0;
public:
	bool cond(const int& e) const {
		cout << "First3ICE.cond " << num << " e=" << e << " == " << 2 << " ?= " <<                                                           (e == 8 || e == 17 || e == 20 || (e >= 23 && e <= 26) || e == 44 || e == 47 || (e >= 50 && e <= 52) || e == 56 || e == 59 || e == 60 || e == 61 || e == 65 || e == 68 || e == 69 || e == 70 || e == 72 || e == 73 || e == 75 || e == 76 || e == 89 || e == 98 || e == 101 || e == 104 || e == 105 || e == 106 || e == 116 || e == 125 || e == 128 || e == 131 || e == 132 || e == 133 || e == 137 || e == 140 || e == 141 || e == 142 || e == 146 || e == 149 || e == 150 || e == 151 || e == 153 || e == 154 || e == 156 || e == 157 || e == 164 || e == 167 || e == 168 || e == 169 || e == 173 || e == 176 || e == 177 || e == 178 || e == 180 || e == 181 || e == 183 || e == 184 || e == 191 || e == 194 || e == 195 || e == 196 || e == 200 || e == 203 || e == 204 || e == 205 || e == 207 || e == 208 || e == 210 || e == 211 || e == 216 || e == 217 || e == 219 || e == 220 || e == 225 || e == 226 || e == 228 || e == 229 || e == 251 || e == 260 || e == 263 || e == 266 || e == 267 || e == 268 || e == 278 || e == 287 || e == 290 || e == 293 || e == 294 || e == 295 || e == 299 || e == 302 || e == 303 || e == 304 || e == 308 || e == 311 || e == 312 || e == 313 || e == 315 || e == 316 || e == 318 || e == 319 || e == 332 || e == 341 || e == 344 || e == 347 || e == 348 || e == 349 || e == 359 || e == 368 || e == 371 || e == 374 || e == 375 || e == 376 || e == 380 || e == 383 || e == 384 || e == 385 || e == 389 || e == 392 || e == 393 || e == 394 || e == 396 || e == 397 || e == 399 || e == 400 || e == 407 || e == 410 || e == 411 || e == 412 || e == 416 || e == 419 || e == 420 || e == 421 || e == 423 || e == 424 || e == 426 || e == 427 || e == 434 || e == 437 || e == 438 || e == 439 || e == 443 || e == 446 || e == 447 || e == 448 || e == 450 || e == 451 || e == 453 || e == 454 || e == 459 || e == 460 || e == 462 || e == 463 || e == 468 || e == 469 || e == 471 || e == 472 || e == 488 || e == 491 || e == 492 || e == 493 || e == 497 || e == 500 || e == 501 || e == 502 || e == 504 || e == 505 || e == 507 || e == 508 || e == 515 || e == 518 || e == 519 || e == 520 || e == 524 || e == 527 || e == 528 || e == 529 || e == 531 || e == 532 || e == 534 || e == 535 || e == 540 || e == 541 || e == 543 || e == 544 || e == 549 || e == 550 || e == 552 || e == 553 || e == 569 || e == 572 || e == 573 || e == 574 || e == 578 || e == 581 || e == 582 || e == 583 || e == 585 || e == 586 || e == 588 || e == 589 || e == 596 || e == 599 || e == 600 || e == 601 || e == 605 || e == 608 || e == 609 || e == 610 || e == 612 || e == 613 || e == 615 || e == 616 || e == 621 || e == 622 || e == 624 || e == 625 || e == 630 || e == 631 || e == 633 || e == 634 || e == 648 || e == 649 || e == 651 || e == 652 || e == 657 || e == 658 || e == 660 || e == 661 || e == 675 || e == 676 || e == 678 || e == 679 || e == 684 || e == 685 || e == 687 || e == 688 || e == 737 || e == 746 || e == 749 || e == 752 || e == 753 || e == 754 || e == 764 || e == 773 || e == 776 || e == 779 || e == 780 || e == 781 || e == 785 || e == 788 || e == 789 || e == 790 || e == 794 || e == 797 || e == 798 || e == 799 || e == 801 || e == 802 || e == 804 || e == 805 || e == 818 || e == 827 || e == 830 || e == 833 || e == 834 || e == 835 || e == 845 || e == 854 || e == 857 || e == 860 || e == 861 || e == 862 || e == 866 || e == 869 || e == 870 || e == 871 || e == 875 || e == 878 || e == 879 || e == 880 || e == 882 || e == 883 || e == 885 || e == 886 || e == 893 || e == 896 || e == 897 || e == 898 || e == 902 || e == 905 || e == 906 || e == 907 || e == 909 || e == 910 || e == 912 || e == 913 || e == 920 || e == 923 || e == 924 || e == 925 || e == 929 || e == 932 || e == 933 || e == 934 || e == 936 || e == 937 || e == 939 || e == 940 || e == 945 || e == 946 || e == 948 || e == 949 || e == 954 || e == 955 || e == 957 || e == 958 || e == 980 || e == 989 || e == 992 || e == 995 || e == 996 || e == 997 || e == 1007 || e == 1016 || e == 1019 || e == 1022 || e == 1023 || e == 1024 || e == 1028 || e == 1031 || e == 1032 || e == 1033 || e == 1037 || e == 1040 || e == 1041 || e == 1042 || e == 1044 || e == 1045 || e == 1047 || e == 1048 || e == 1061 || e == 1070 || e == 1073 || e == 1076 || e == 1077 || e == 1078 || e == 1088 || e == 1097 || e == 1100 || e == 1103 || e == 1104 || e == 1105 || e == 1109 || e == 1112 || e == 1113 || e == 1114 || e == 1118 || e == 1121 || e == 1122 || e == 1123 || e == 1125 || e == 1126 || e == 1128 || e == 1129 || e == 1136 || e == 1139 || e == 1140 || e == 1141 || e == 1145 || e == 1148 || e == 1149 || e == 1150 || e == 1152 || e == 1153 || e == 1155 || e == 1156 || e == 1163 || e == 1166 || e == 1167 || e == 1168 || e == 1172 || e == 1175 || e == 1176 || e == 1177 || e == 1179 || e == 1180 || e == 1182 || e == 1183 || e == 1188 || e == 1189 || e == 1191 || e == 1192 || e == 1197 || e == 1198 || e == 1200 || e == 1201 || e == 1217 || e == 1220 || e == 1221 || e == 1222 || e == 1226 || e == 1229 || e == 1230 || e == 1231 || e == 1233 || e == 1234 || e == 1236 || e == 1237 || e == 1244 || e == 1247 || e == 1248 || e == 1249 || e == 1253 || e == 1256 || e == 1257 || e == 1258 || e == 1260 || e == 1261 || e == 1263 || e == 1264 || e == 1269 || e == 1270 || e == 1272 || e == 1273 || e == 1278 || e == 1279 || e == 1281 || e == 1282 || e == 1298 || e == 1301 || e == 1302 || e == 1303 || e == 1307 || e == 1310 || e == 1311 || e == 1312 || e == 1314 || e == 1315 || e == 1317 || e == 1318 || e == 1325 || e == 1328 || e == 1329 || e == 1330 || e == 1334 || e == 1337 || e == 1338 || e == 1339 || e == 1341 || e == 1342 || e == 1344 || e == 1345 || e == 1350 || e == 1351 || e == 1353 || e == 1354 || e == 1359 || e == 1360 || e == 1362 || e == 1363 || e == 1377 || e == 1378 || e == 1380 || e == 1381 || e == 1386 || e == 1387 || e == 1389 || e == 1390 || e == 1404 || e == 1405 || e == 1407 || e == 1408 || e == 1413 || e == 1414 || e == 1416 || e == 1417 || e == 1460 || e == 1463 || e == 1464 || e == 1465 || e == 1469 || e == 1472 || e == 1473 || e == 1474 || e == 1476 || e == 1477 || e == 1479 || e == 1480 || e == 1487 || e == 1490 || e == 1491 || e == 1492 || e == 1496 || e == 1499 || e == 1500 || e == 1501 || e == 1503 || e == 1504 || e == 1506 || e == 1507 || e == 1512 || e == 1513 || e == 1515 || e == 1516 || e == 1521 || e == 1522 || e == 1524 || e == 1525 || e == 1541 || e == 1544 || e == 1545 || e == 1546 || e == 1550 || e == 1553 || e == 1554 || e == 1555 || e == 1557 || e == 1558 || e == 1560 || e == 1561 || e == 1568 || e == 1571 || e == 1572 || e == 1573 || e == 1577 || e == 1580 || e == 1581 || e == 1582 || e == 1584 || e == 1585 || e == 1587 || e == 1588 || e == 1593 || e == 1594 || e == 1596 || e == 1597 || e == 1602 || e == 1603 || e == 1605 || e == 1606 || e == 1620 || e == 1621 || e == 1623 || e == 1624 || e == 1629 || e == 1630 || e == 1632 || e == 1633 || e == 1647 || e == 1648 || e == 1650 || e == 1651 || e == 1656 || e == 1657 || e == 1659 || e == 1660 || e == 1703 || e == 1706 || e == 1707 || e == 1708 || e == 1712 || e == 1715 || e == 1716 || e == 1717 || e == 1719 || e == 1720 || e == 1722 || e == 1723 || e == 1730 || e == 1733 || e == 1734 || e == 1735 || e == 1739 || e == 1742 || e == 1743 || e == 1744 || e == 1746 || e == 1747 || e == 1749 || e == 1750 || e == 1755 || e == 1756 || e == 1758 || e == 1759 || e == 1764 || e == 1765 || e == 1767 || e == 1768 || e == 1784 || e == 1787 || e == 1788 || e == 1789 || e == 1793 || e == 1796 || e == 1797 || e == 1798 || e == 1800 || e == 1801 || e == 1803 || e == 1804 || e == 1811 || e == 1814 || e == 1815 || e == 1816 || e == 1820 || e == 1823 || e == 1824 || e == 1825 || e == 1827 || e == 1828 || e == 1830 || e == 1831 || e == 1836 || e == 1837 || e == 1839 || e == 1840 || e == 1845 || e == 1846 || e == 1848 || e == 1849 || e == 1863 || e == 1864 || e == 1866 || e == 1867 || e == 1872 || e == 1873 || e == 1875 || e == 1876 || e == 1890 || e == 1891 || e == 1893 || e == 1894 || e == 1899 || e == 1900 || e == 1902 || e == 1903 || e == 1944 || e == 1945 || e == 1947 || e == 1948 || e == 1953 || e == 1954 || e == 1956 || e == 1957 || e == 1971 || e == 1972 || e == 1974 || e == 1975 || e == 1980 || e == 1981 || e == 1983 || e == 1984 || e == 2025 || e == 2026 || e == 2028 || e == 2029 || e == 2034 || e == 2035 || e == 2037 || e == 2038 || e == 2052 || e == 2053 || e == 2055 || e == 2056 || e == 2061 || e == 2062 || e == 2064 || e == 2065 || e == 2195 || e == 2204 || e == 2207 || e == 2210 || e == 2211 || e == 2212 || e == 2222 || e == 2231 || e == 2234 || e == 2237 || e == 2238 || e == 2239 || e == 2243 || e == 2246 || e == 2247 || e == 2248 || e == 2252 || e == 2255 || e == 2256 || e == 2257 || e == 2259 || e == 2260 || e == 2262 || e == 2263 || e == 2276 || e == 2285 || e == 2288 || e == 2291 || e == 2292 || e == 2293 || e == 2303 || e == 2312 || e == 2315 || e == 2318 || e == 2319 || e == 2320 || e == 2324 || e == 2327 || e == 2328) << endl;
		return /* e==2 ;*/                                                                                                                    e == 8 || e == 17 || e == 20 || (e >= 23 && e <= 26) || e == 44 || e == 47 || (e >= 50 && e <= 52) || e == 56 || e == 59 || e == 60 || e == 61 || e == 65 || e == 68 || e == 69 || e == 70 || e == 72 || e == 73 || e == 75 || e == 76 || e == 89 || e == 98 || e == 101 || e == 104 || e == 105 || e == 106 || e == 116 || e == 125 || e == 128 || e == 131 || e == 132 || e == 133 || e == 137 || e == 140 || e == 141 || e == 142 || e == 146 || e == 149 || e == 150 || e == 151 || e == 153 || e == 154 || e == 156 || e == 157 || e == 164 || e == 167 || e == 168 || e == 169 || e == 173 || e == 176 || e == 177 || e == 178 || e == 180 || e == 181 || e == 183 || e == 184 || e == 191 || e == 194 || e == 195 || e == 196 || e == 200 || e == 203 || e == 204 || e == 205 || e == 207 || e == 208 || e == 210 || e == 211 || e == 216 || e == 217 || e == 219 || e == 220 || e == 225 || e == 226 || e == 228 || e == 229 || e == 251 || e == 260 || e == 263 || e == 266 || e == 267 || e == 268 || e == 278 || e == 287 || e == 290 || e == 293 || e == 294 || e == 295 || e == 299 || e == 302 || e == 303 || e == 304 || e == 308 || e == 311 || e == 312 || e == 313 || e == 315 || e == 316 || e == 318 || e == 319 || e == 332 || e == 341 || e == 344 || e == 347 || e == 348 || e == 349 || e == 359 || e == 368 || e == 371 || e == 374 || e == 375 || e == 376 || e == 380 || e == 383 || e == 384 || e == 385 || e == 389 || e == 392 || e == 393 || e == 394 || e == 396 || e == 397 || e == 399 || e == 400 || e == 407 || e == 410 || e == 411 || e == 412 || e == 416 || e == 419 || e == 420 || e == 421 || e == 423 || e == 424 || e == 426 || e == 427 || e == 434 || e == 437 || e == 438 || e == 439 || e == 443 || e == 446 || e == 447 || e == 448 || e == 450 || e == 451 || e == 453 || e == 454 || e == 459 || e == 460 || e == 462 || e == 463 || e == 468 || e == 469 || e == 471 || e == 472 || e == 488 || e == 491 || e == 492 || e == 493 || e == 497 || e == 500 || e == 501 || e == 502 || e == 504 || e == 505 || e == 507 || e == 508 || e == 515 || e == 518 || e == 519 || e == 520 || e == 524 || e == 527 || e == 528 || e == 529 || e == 531 || e == 532 || e == 534 || e == 535 || e == 540 || e == 541 || e == 543 || e == 544 || e == 549 || e == 550 || e == 552 || e == 553 || e == 569 || e == 572 || e == 573 || e == 574 || e == 578 || e == 581 || e == 582 || e == 583 || e == 585 || e == 586 || e == 588 || e == 589 || e == 596 || e == 599 || e == 600 || e == 601 || e == 605 || e == 608 || e == 609 || e == 610 || e == 612 || e == 613 || e == 615 || e == 616 || e == 621 || e == 622 || e == 624 || e == 625 || e == 630 || e == 631 || e == 633 || e == 634 || e == 648 || e == 649 || e == 651 || e == 652 || e == 657 || e == 658 || e == 660 || e == 661 || e == 675 || e == 676 || e == 678 || e == 679 || e == 684 || e == 685 || e == 687 || e == 688 || e == 737 || e == 746 || e == 749 || e == 752 || e == 753 || e == 754 || e == 764 || e == 773 || e == 776 || e == 779 || e == 780 || e == 781 || e == 785 || e == 788 || e == 789 || e == 790 || e == 794 || e == 797 || e == 798 || e == 799 || e == 801 || e == 802 || e == 804 || e == 805 || e == 818 || e == 827 || e == 830 || e == 833 || e == 834 || e == 835 || e == 845 || e == 854 || e == 857 || e == 860 || e == 861 || e == 862 || e == 866 || e == 869 || e == 870 || e == 871 || e == 875 || e == 878 || e == 879 || e == 880 || e == 882 || e == 883 || e == 885 || e == 886 || e == 893 || e == 896 || e == 897 || e == 898 || e == 902 || e == 905 || e == 906 || e == 907 || e == 909 || e == 910 || e == 912 || e == 913 || e == 920 || e == 923 || e == 924 || e == 925 || e == 929 || e == 932 || e == 933 || e == 934 || e == 936 || e == 937 || e == 939 || e == 940 || e == 945 || e == 946 || e == 948 || e == 949 || e == 954 || e == 955 || e == 957 || e == 958 || e == 980 || e == 989 || e == 992 || e == 995 || e == 996 || e == 997 || e == 1007 || e == 1016 || e == 1019 || e == 1022 || e == 1023 || e == 1024 || e == 1028 || e == 1031 || e == 1032 || e == 1033 || e == 1037 || e == 1040 || e == 1041 || e == 1042 || e == 1044 || e == 1045 || e == 1047 || e == 1048 || e == 1061 || e == 1070 || e == 1073 || e == 1076 || e == 1077 || e == 1078 || e == 1088 || e == 1097 || e == 1100 || e == 1103 || e == 1104 || e == 1105 || e == 1109 || e == 1112 || e == 1113 || e == 1114 || e == 1118 || e == 1121 || e == 1122 || e == 1123 || e == 1125 || e == 1126 || e == 1128 || e == 1129 || e == 1136 || e == 1139 || e == 1140 || e == 1141 || e == 1145 || e == 1148 || e == 1149 || e == 1150 || e == 1152 || e == 1153 || e == 1155 || e == 1156 || e == 1163 || e == 1166 || e == 1167 || e == 1168 || e == 1172 || e == 1175 || e == 1176 || e == 1177 || e == 1179 || e == 1180 || e == 1182 || e == 1183 || e == 1188 || e == 1189 || e == 1191 || e == 1192 || e == 1197 || e == 1198 || e == 1200 || e == 1201 || e == 1217 || e == 1220 || e == 1221 || e == 1222 || e == 1226 || e == 1229 || e == 1230 || e == 1231 || e == 1233 || e == 1234 || e == 1236 || e == 1237 || e == 1244 || e == 1247 || e == 1248 || e == 1249 || e == 1253 || e == 1256 || e == 1257 || e == 1258 || e == 1260 || e == 1261 || e == 1263 || e == 1264 || e == 1269 || e == 1270 || e == 1272 || e == 1273 || e == 1278 || e == 1279 || e == 1281 || e == 1282 || e == 1298 || e == 1301 || e == 1302 || e == 1303 || e == 1307 || e == 1310 || e == 1311 || e == 1312 || e == 1314 || e == 1315 || e == 1317 || e == 1318 || e == 1325 || e == 1328 || e == 1329 || e == 1330 || e == 1334 || e == 1337 || e == 1338 || e == 1339 || e == 1341 || e == 1342 || e == 1344 || e == 1345 || e == 1350 || e == 1351 || e == 1353 || e == 1354 || e == 1359 || e == 1360 || e == 1362 || e == 1363 || e == 1377 || e == 1378 || e == 1380 || e == 1381 || e == 1386 || e == 1387 || e == 1389 || e == 1390 || e == 1404 || e == 1405 || e == 1407 || e == 1408 || e == 1413 || e == 1414 || e == 1416 || e == 1417 || e == 1460 || e == 1463 || e == 1464 || e == 1465 || e == 1469 || e == 1472 || e == 1473 || e == 1474 || e == 1476 || e == 1477 || e == 1479 || e == 1480 || e == 1487 || e == 1490 || e == 1491 || e == 1492 || e == 1496 || e == 1499 || e == 1500 || e == 1501 || e == 1503 || e == 1504 || e == 1506 || e == 1507 || e == 1512 || e == 1513 || e == 1515 || e == 1516 || e == 1521 || e == 1522 || e == 1524 || e == 1525 || e == 1541 || e == 1544 || e == 1545 || e == 1546 || e == 1550 || e == 1553 || e == 1554 || e == 1555 || e == 1557 || e == 1558 || e == 1560 || e == 1561 || e == 1568 || e == 1571 || e == 1572 || e == 1573 || e == 1577 || e == 1580 || e == 1581 || e == 1582 || e == 1584 || e == 1585 || e == 1587 || e == 1588 || e == 1593 || e == 1594 || e == 1596 || e == 1597 || e == 1602 || e == 1603 || e == 1605 || e == 1606 || e == 1620 || e == 1621 || e == 1623 || e == 1624 || e == 1629 || e == 1630 || e == 1632 || e == 1633 || e == 1647 || e == 1648 || e == 1650 || e == 1651 || e == 1656 || e == 1657 || e == 1659 || e == 1660 || e == 1703 || e == 1706 || e == 1707 || e == 1708 || e == 1712 || e == 1715 || e == 1716 || e == 1717 || e == 1719 || e == 1720 || e == 1722 || e == 1723 || e == 1730 || e == 1733 || e == 1734 || e == 1735 || e == 1739 || e == 1742 || e == 1743 || e == 1744 || e == 1746 || e == 1747 || e == 1749 || e == 1750 || e == 1755 || e == 1756 || e == 1758 || e == 1759 || e == 1764 || e == 1765 || e == 1767 || e == 1768 || e == 1784 || e == 1787 || e == 1788 || e == 1789 || e == 1793 || e == 1796 || e == 1797 || e == 1798 || e == 1800 || e == 1801 || e == 1803 || e == 1804 || e == 1811 || e == 1814 || e == 1815 || e == 1816 || e == 1820 || e == 1823 || e == 1824 || e == 1825 || e == 1827 || e == 1828 || e == 1830 || e == 1831 || e == 1836 || e == 1837 || e == 1839 || e == 1840 || e == 1845 || e == 1846 || e == 1848 || e == 1849 || e == 1863 || e == 1864 || e == 1866 || e == 1867 || e == 1872 || e == 1873 || e == 1875 || e == 1876 || e == 1890 || e == 1891 || e == 1893 || e == 1894 || e == 1899 || e == 1900 || e == 1902 || e == 1903 || e == 1944 || e == 1945 || e == 1947 || e == 1948 || e == 1953 || e == 1954 || e == 1956 || e == 1957 || e == 1971 || e == 1972 || e == 1974 || e == 1975 || e == 1980 || e == 1981 || e == 1983 || e == 1984 || e == 2025 || e == 2026 || e == 2028 || e == 2029 || e == 2034 || e == 2035 || e == 2037 || e == 2038 || e == 2052 || e == 2053 || e == 2055 || e == 2056 || e == 2061 || e == 2062 || e == 2064 || e == 2065 || e == 2195 || e == 2204 || e == 2207 || e == 2210 || e == 2211 || e == 2212 || e == 2222 || e == 2231 || e == 2234 || e == 2237 || e == 2238 || e == 2239 || e == 2243 || e == 2246 || e == 2247 || e == 2248 || e == 2252 || e == 2255 || e == 2256 || e == 2257 || e == 2259 || e == 2260 || e == 2262 || e == 2263 || e == 2276 || e == 2285 || e == 2288 || e == 2291 || e == 2292 || e == 2293 || e == 2303 || e == 2312 || e == 2315 || e == 2318 || e == 2319 || e == 2320 || e == 2324 || e == 2327 || e == 2328;
	}
	//First3ICE(int n) : num(n) {}
};

int main() {
	Enum3ICE s("input.txt");
	First3ICE f;
	f.addEnumerator(&s);
	f.run();
	cout << endl << endl << "Eredmeny: ";
	if (f.found()) cout << f.elem() << endl;
	else cout << "Nincs talalat!" << endl;
	char c; cin >> c;
	return 0;
}